package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	import flash.geom.Point;
	import flash.text.TextField;
	
	/**
	 * ...
	 * @author Kegogrog
	 */
	public class Main extends Sprite 
	{
		public var sprite1:Sprite;
		public var sprite2:Sprite;
		
		public var point10:Point;
		public var point20:Point;
		
		public var point14:Point;
		public var point21:Point;
		
		public var actSprite:Sprite;
		public var parallax:Point;
		public var overlay:Sprite;
		
		public var tf:TextField;
		
		public var rotate:Boolean = true;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			tf = new TextField();
			addChild(tf);
			
			
			sprite1 = new Sprite();
			sprite1.graphics.lineStyle(0);
			sprite1.graphics.beginFill(0x0000ff);
			sprite1.graphics.drawRect( -25, -25, 50, 50);
			sprite1.graphics.endFill();
			
			sprite1.graphics.beginFill(0xff0000);
			sprite1.graphics.drawCircle(0, 0, 10);
			sprite1.graphics.drawCircle(0, 25, 5);
			sprite1.graphics.endFill();
			addChild(sprite1);
			
			sprite1.x = 200;
			sprite1.y = 100;
			sprite1.alpha = 0.5;
			
			sprite2 = new Sprite();
			sprite2.graphics.lineStyle(0);
			sprite2.graphics.beginFill(0x00ff00);
			sprite2.graphics.drawRect( -25, -25, 50, 50);
			sprite2.graphics.endFill();
			
			sprite2.graphics.beginFill(0xff0000);
			sprite2.graphics.drawCircle(0, 0, 10);
			sprite2.graphics.drawCircle(0, -25, 5);
			sprite2.graphics.endFill();
			addChild(sprite2);
			
			sprite2.x = 300;
			sprite2.y = 200;
			sprite2.alpha = 0.5;
			
			point10 = new Point(sprite1.x, sprite1.y);
			point20 = new Point(sprite2.x, sprite2.y);
			
			point14 = new Point(sprite1.x, sprite1.y + 25);
			point21 = new Point(sprite2.x, sprite2.y - 25);
			
			overlay = new Sprite();
			addChild(overlay);
			overlay.mouseEnabled = false;
			
			this.addEventListener(Event.ENTER_FRAME, loop);
			
			this.addEventListener(MouseEvent.MOUSE_DOWN, pickTile);
		}
		
		public function loop(event:Event):void
		{
			if ( actSprite )
			{
				actSprite.x = stage.mouseX - parallax.x;
				actSprite.y = stage.mouseY - parallax.y;
			}
			
			point10 = new Point(sprite1.x, sprite1.y);
			point20 = new Point(sprite2.x, sprite2.y);
			
			point14 = (new Point(sprite1.x - Math.sin(sprite1.rotation * Math.PI/180) * 25, sprite1.y + Math.cos(sprite1.rotation * Math.PI/180) * 25));
			point21 = (new Point(sprite2.x - Math.sin(sprite2.rotation * Math.PI/180) * -25, sprite2.y + Math.cos(sprite2.rotation * Math.PI/180) * -25));
			
			overlay.graphics.clear();
			
			overlay.graphics.lineStyle(0, 0xff0000);
			overlay.graphics.moveTo(point10.x, point10.y);
			overlay.graphics.lineTo(point20.x, point20.y);
			var dist1:Number = Point.distance(point10, point20);
			
			overlay.graphics.moveTo(point14.x, point14.y);
			overlay.graphics.lineTo(point21.x, point21.y);
			var dist2:Number = Point.distance(point14, point21);
			
			tf.text = Math.round(dist1).toString() + "\n" + Math.round(dist2).toString() + "\nSumme: " + Math.round(dist1 + dist2).toString() + "\nDifferenz: " + Math.round(dist1 - dist2).toString() + "\n" + (dist1 >= 45 && dist1 <= 55 && dist2 <= 5).toString();;
			if (dist1 >= 45 && dist1 <= 55 && dist2 <= 5)
			{
				this.filters = [ new GlowFilter() ];
			}
			else
			{
				this.filters = [];
			}
		}
		
		public function pickTile(event:MouseEvent):void
		{
			rotate = true;
			if ( event.target is Sprite )
			{
				stage.removeEventListener(MouseEvent.MOUSE_DOWN, pickTile);
				stage.addEventListener(MouseEvent.MOUSE_MOVE, mouseMoveHandler);
				actSprite = event.target as Sprite;
				parallax = new Point( - actSprite.x + stage.mouseX, - actSprite.y + stage.mouseY);
				//parallax = new Point( actSprite.mouseX, actSprite.mouseY);
				stage.addEventListener(MouseEvent.MOUSE_UP, dropTile);
			}
		}
		
		public function dropTile(event:MouseEvent):void
		{
			stage.removeEventListener(MouseEvent.MOUSE_UP, dropTile);
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, mouseMoveHandler);
			if ( event.target is Sprite && rotate == true )
			{
				event.target.rotation += 90;
			}
			actSprite = null;
			parallax = null;
			stage.addEventListener(MouseEvent.MOUSE_DOWN, pickTile);
		}
		
		public function mouseMoveHandler(event:MouseEvent):void
		{
			rotate = false;
		}
		
	}
	
}